//+------------------------------------------------------------------+
//|                                                        mateo.mq4 |
//+------------------------------------------------------------------+

extern double Lots=0.10;
extern int TP=20;
extern int SL=80;

extern int EMA1_Period=10;
extern int EMA2_Period=21;
extern int EMA_on_SMA_Angle_Period=21;
extern int SMAPeriod=50;
extern double AngleTreshold=0.22;
extern int StartSMAShift=2;
extern int EndSMAShift=0;

extern int EMA1_EMA2_Distance=5;
extern double SMA_angle_buy=0.22;
extern double SMA_angle_sell=-0.22;
extern double EMAonAngle_buy=0.10;
extern double EMAonAngle_sell=-0.10;
extern int X_Retrace=10;

extern bool Use_Time_Frame1=false;
extern int Start_Hour1=9;
extern int Start_Minute1=30;
extern int Stop_Hour1=11;
extern int Stop_Minute1=30;

extern bool Use_Time_Frame2=false;
extern int Start_Hour2=15;
extern int Start_Minute2=00;
extern int Stop_Hour2=18;
extern int Stop_Minute2=30;

extern bool Use_Time_Frame3=false;
extern int Start_Hour3=3;
extern int Start_Minute3=30;
extern int Stop_Hour3=6;
extern int Stop_Minute3=30;

extern bool Take_Partial_Profit=false;
extern int Take_Partial_Profit_Value=10;
extern double Lots_to_Close_At_partial_TP=0.10;

extern bool Martingale=false;
extern double Lot_Multiplication_Factor=2;
extern int Martingale_Loss=40; // after a loss of this number of pips it will increase the lot size by multiplier

extern bool X_Trades_per_Hour=false;
extern int Trades_per_Hour=10; // the maximum number of trades per hour.

extern int Slippage=3;
extern int TradeBar_Ema1=1;
extern int TradeBar_Ema2=1;
extern int TradeBar_Sma_Angle=1;
extern int TradeBar_Ema_Sma_Angle=1;
extern int Magic_Number=845;


string com="mateo";

int init(){return(0);}
int deinit(){return(0);}
int start()
  {
   double l=0;
   int i=0;
   double ask=0,bid=0;
                
   if (TotalOrders(Magic_Number)==0 && 
        (!X_Trades_per_Hour || (X_Trades_per_Hour && trades_hour(Magic_Number,TimeHour(TimeCurrent()))<Trades_per_Hour)) &&
        ((!Use_Time_Frame1 && !Use_Time_Frame2 && !Use_Time_Frame3) ||
         (Use_Time_Frame1 && (TimeHour(TimeCurrent())>Start_Hour1 || (TimeHour(TimeCurrent())==Start_Hour1 && TimeMinute(TimeCurrent())>=Start_Minute1)) &&
               (TimeHour(TimeCurrent())<Stop_Hour1 || (TimeHour(TimeCurrent())==Stop_Hour1 && TimeMinute(TimeCurrent())<Start_Minute1))) ||
         (Use_Time_Frame2 && (TimeHour(TimeCurrent())>Start_Hour2 || (TimeHour(TimeCurrent())==Start_Hour2 && TimeMinute(TimeCurrent())>=Start_Minute2)) &&
               (TimeHour(TimeCurrent())<Stop_Hour2 || (TimeHour(TimeCurrent())==Stop_Hour2 && TimeMinute(TimeCurrent())<Start_Minute2))) ||           
         (Use_Time_Frame3 && (TimeHour(TimeCurrent())>Start_Hour3 || (TimeHour(TimeCurrent())==Start_Hour3 && TimeMinute(TimeCurrent())>=Start_Minute3)) &&
               (TimeHour(TimeCurrent())<Stop_Hour3 || (TimeHour(TimeCurrent())==Stop_Hour3 && TimeMinute(TimeCurrent())<Start_Minute3))))
       ){      
      double ema1=iMA(Symbol(),0,EMA1_Period,0,MODE_EMA,PRICE_CLOSE,TradeBar_Ema1);   
      double ema2=iMA(Symbol(),0,EMA2_Period,0,MODE_EMA,PRICE_CLOSE,TradeBar_Ema2);   
      double sma_angle=iCustom(Symbol(),0,"SMAAngle",SMAPeriod,AngleTreshold,StartSMAShift,EndSMAShift,0,TradeBar_Sma_Angle);
      double e=iCustom(Symbol(),0,"MA_of_SMA_ANGLE",EMA_on_SMA_Angle_Period,SMAPeriod,AngleTreshold,StartSMAShift,EndSMAShift,0,TradeBar_Ema_Sma_Angle);
      double e1=iCustom(Symbol(),0,"MA_of_SMA_ANGLE",EMA_on_SMA_Angle_Period,SMAPeriod,AngleTreshold,StartSMAShift,EndSMAShift,0,TradeBar_Ema_Sma_Angle);       
      if (Martingale && last_lot(Magic_Number,Martingale_Loss)>0){
            l=last_lot(Magic_Number,Martingale_Loss)*Lot_Multiplication_Factor;
      } else{
            l=Lots;
      }       
      if (sma_angle>SMA_angle_buy && 
          Ask<MathMax(ema1,ema2) && Ask>MathMin(ema1,ema2) && 
          Ask<ema1-X_Retrace*Point && 
          MathAbs(ema1-ema2)>=EMA1_EMA2_Distance*Point && 
          e>EMAonAngle_buy ){//&& e1<=EMAonAngle_buy){
          RefreshRates();
          ask=MarketInfo(Symbol(),MODE_ASK);
          if (OrderSend(Symbol(),OP_BUY,NormalizeDouble(l,1),NormalizeDouble(ask,Digits),Slippage,NormalizeDouble(ask-SL*Point,Digits),NormalizeDouble(ask+TP*Point,Digits),com,Magic_Number,0,Blue)==-1){
               i=GetLastError();
               if (i!=1 && i!=0) Print("Buy Error :"+error(i)+" at "+Symbol()+" "+Period());                                               
          }
      }
      
      if (sma_angle<SMA_angle_sell && 
          Bid<MathMax(ema1,ema2) && Bid>MathMin(ema1,ema2) && 
           Bid>ema1+X_Retrace*Point && 
          MathAbs(ema1-ema2)>=EMA1_EMA2_Distance*Point && 
          e<EMAonAngle_sell ){//&& e1>=EMAonAngle_sell){          
          RefreshRates();
          bid=MarketInfo(Symbol(),MODE_BID);
          if (OrderSend(Symbol(),OP_SELL,NormalizeDouble(l,1),NormalizeDouble(bid,Digits),Slippage,NormalizeDouble(bid+SL*Point,Digits),NormalizeDouble(bid-TP*Point,Digits),com,Magic_Number,0,Red)==-1){
               i=GetLastError();
               if (i!=1 && i!=0) Print("Sell Error :"+error(i)+" at "+Symbol()+" "+Period());                                               
          }
      }          
   }
   
   if (TotalOrders(Magic_Number)==1 && Take_Partial_Profit){
      for (int k=0;k<OrdersTotal();k++){
         OrderSelect(k,SELECT_BY_POS);
         RefreshRates();
         bid=MarketInfo(Symbol(),MODE_BID);
         ask=MarketInfo(Symbol(),MODE_ASK);
         if (OrderMagicNumber()==Magic_Number && OrderType()==OP_BUY && bid-OrderOpenPrice()>=Take_Partial_Profit_Value*Point && OrderLots()>=Lots_to_Close_At_partial_TP){
            if (!OrderClose(OrderTicket(),NormalizeDouble(Lots_to_Close_At_partial_TP,2),NormalizeDouble(bid,Digits),Slippage,Pink)){
               i=GetLastError();
               if (i!=1 && i!=0) Print("Close BUY Error :"+error(i)+" at "+Symbol()+" "+Period());                                                              
            }
            break;
         }
         if (OrderMagicNumber()==Magic_Number && OrderType()==OP_SELL && OrderOpenPrice()-ask>=Take_Partial_Profit_Value*Point && OrderLots()>=Lots_to_Close_At_partial_TP){
            if (!OrderClose(OrderTicket(),NormalizeDouble(Lots_to_Close_At_partial_TP,2),NormalizeDouble(ask,Digits),Slippage,Pink)){
               i=GetLastError();
               if (i!=1 && i!=0) Print("Close SELL Error :"+error(i)+" at "+Symbol()+" "+Period());                                                              
            }
            break;
         }         
      }      
   }
   
   return(0);
  }

int trades_hour(int m,int h){
   int rez=0;
   for (int i=0;i<OrdersHistoryTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if (OrderMagicNumber()==m && (OrderType()==OP_BUY || OrderType()==OP_SELL) &&
          TimeHour(OrderOpenTime())==h && TimeDay(OrderOpenTime())==TimeDay(TimeCurrent())){
          rez++;
      }
   }
   return (rez);   
}

double last_lot(int m,int p){
   datetime b=0;
   double rez=0;
   for (int i=0;i<OrdersHistoryTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if (OrderMagicNumber()==m && (OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderOpenTime()>b && 
          OrderProfit()<0 && MathAbs(OrderOpenPrice()-OrderClosePrice())>=p*Point){
          rez=OrderLots();
          b=OrderOpenTime();
      }
   }
   return (rez);
}

int TotalOrders(int magic){
   int rez=0;
   for (int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS);
      if (OrderMagicNumber()==magic){
         rez++;
      }
   }   
   return(rez);
} 
string error(int err){
switch (err){
 case 0 :return("No error returned.");
 case 1 :return("No error returned, but the result is unknown. ");
 case 2 :return("Common error. ");
 case 3 :return("Invalid trade parameters. ");
 case 4 :return("Trade server is busy. ");
 case 5 :return("Old version of the client terminal. ");
 case 6 :return("No connection with trade server. ");
 case 7 :return("Not enough rights. ");
 case 8 :return("Too frequent requests."); 
 case 9 :return("Malfunctional trade operation. ");
 case 64 :return("Account disabled. ");
 case 65 :return("Invalid account. ");
 case 128 :return("Trade timeout. ");
 case 129 :return("Invalid price. ");
 case 130 :return("Invalid stops. ");
 case 131 :return("Invalid trade volume. ");
 case 132 :return("Market is closed. ");
 case 133 :return("Trade is disabled. ");
 case 134 :return("Not enough money. ");
 case 135 :return("Price changed. ");
 case 136 :return("Off quotes. ");
 case 137 :return("Broker is busy."); 
 case 138 :return("Requote. ");
 case 139 :return("Order is locked. ");
 case 140 :return("Long positions only allowed. ");
 case 141 :return("Too many requests. ");
 case 145 :return("Modification denied because order too close to market. ");
 case 146 :return("Trade context is busy. ");
 case 147 :return("Expirations are denied by broker. ");
 case 148 :return("The amount of open and pending orders has reached the limit set by the broker. ");
 case 4000 :return("No error. ");
 case 4001 :return("Wrong function pointer. ");
 case 4002 :return("Array index is out of range. ");
 case 4003 :return("No memory for function call stack. ");
 case 4004 :return("Recursive stack overflow. ");
 case 4005 :return("Not enough stack for parameter. ");
 case 4006 :return("No memory for parameter string. ");
 case 4007 :return("No memory for temp string. ");
 case 4008 :return("Not initialized string. ");
 case 4009 :return("Not initialized string in array. ");
 case 4010 :return("No memory for array string. ");
 case 4011 :return("Too long string. ");
 case 4012 :return("Remainder from zero divide. ");
 case 4013 :return("Zero divide. ");
 case 4014 :return("Unknown command. ");
 case 4015 :return("Wrong jump (never generated error). ");
 case 4016 :return("Not initialized array. ");
 case 4017 :return("DLL calls are not allowed. ");
 case 4018 :return("Cannot load library. ");
 case 4019 :return("Cannot call function. ");
 case 4020 :return("Expert function calls are not allowed. ");
 case 4021 :return("Not enough memory for temp string returned from function. ");
 case 4022 :return("System is busy (never generated error). ");
 case 4050 :return("Invalid function parameters count. ");
 case 4051 :return("Invalid function parameter value. ");
 case 4052 :return("String function internal error. ");
 case 4053 :return("Some array error. ");
 case 4054 :return("Incorrect series array using. ");
 case 4055 :return("Custom indicator error. ");
 case 4056 :return("Arrays are incompatible. ");
 case 4057 :return("Global variables processing error. ");
 case 4058 :return("Global variable not found. ");
 case 4059 :return("Function is not allowed in testing mode. ");
 case 4060 :return("Function is not confirmed. ");
 case 4061 :return("Send mail error. ");
 case 4062 :return("String parameter expected. ");
 case 4063 :return("Integer parameter expected. ");
 case 4064 :return("Double parameter expected. ");
 case 4065 :return("Array as parameter expected. ");
 case 4066 :return("Requested history data in updating state. ");
 case 4067 :return("Some error in trading function. ");
 case 4099 :return("End of file. ");
 case 4100 :return("Some file error."); 
 case 4101 :return("Wrong file name. ");
 case 4102 :return("Too many opened files. ");
 case 4103 :return("Cannot open file. ");
 case 4104 :return("Incompatible access to a file. ");
 case 4105 :return("No order selected. ");
 case 4106 :return("Unknown symbol. ");
 case 4107 :return("Invalid price. ");
 case 4108 :return("Invalid ticket. ");
 case 4109 :return("Trade is not allowed. ");
 case 4110 :return("Longs are not allowed. ");
 case 4111 :return("Shorts are not allowed. ");
 case 4200 :return("Object exists already. ");
 case 4201 :return("Unknown object property. ");
 case 4202 :return("Object does not exist. ");
 case 4203 :return("Unknown object type. ");
 case 4204 :return("No object name. ");
 case 4205 :return("Object coordinates error. ");
 case 4206 :return("No specified subwindow. ");
 case 4207 :return("Some error in object function. ");
 default: return("Unknown error:"+err);
}
}